﻿	function Errorhandling(error, file, row)
    {
      alert("Error: " + error + "\nFile: " + file + "\nRow: " + row);
    }
	
	var maxOrder = 4;
    var a = new Array(8);
	var b = new Array(8);
	var actKnot;
	var knotName;

    function calcDet (m, order)
    {
        var i,j, k;
        var sign = 1.0;
        var dm = 0;
        if (order <= 2)
        {
            return m[0][0] * m[1][1] - m[1][0] * m[0][1]; 
        }
        else
        {
            var mm = new Array(order - 1); // temporary matrix
			for (i = 0; i < order-1; i++) 
				mm[i] = new Array(order - 1);
            for (i = 0; i < order; i++) // index for the element of the top row
            {
                for(j=0; j < order-1; j++) // index that runs down from second row to n
                {
                    for(k=0; k < order-1; k++) // index to copy the elements into a sub matrix
                    {
                        if (j < i)
                            mm[j][k] = m[j][k+1];
                        else
                            mm[j][k] = m[j+1][k+1];
                    }                        
                }
                dm = dm + sign * calcDet(mm, order - 1) * m[i][0];
                sign = -sign;
            }
            return dm;
		}
	}

    function  invert()
    {
		for(var i=0; i < maxOrder; i++)
        {
			a[i] = new Array(maxOrder);
			b[i] = new Array(maxOrder);
			for(var j=0; j < maxOrder; j++)
			{
				a[i][j] = document.getElementById("A" + (i+1) + (j+1)).value; 
			}
		}
        var det = calcDet(a, maxOrder);

        var x, y, j, k;
        var signy = 1.0;
        var signx = 1.0;
        if (det != 0)
        {
            if (maxOrder <= 2)
            {
                // return m.a[0, 0] * m.a[1, 1] - m.a[1, 0] * m.a[0, 1];
            }
            else
            {
                var mm = new Array(maxOrder - 1); // temporary matrix
			    for (i = 0; i < maxOrder-1; i++) 
				    mm[i] = new Array(maxOrder - 1);
                for (x = 0; x < maxOrder; x++)
                {
                    signy = 1.0;
                    for (y = 0; y < maxOrder; y++) // index for the element of the top row
                    {
                        for (j = 0; j < maxOrder - 1; j++) // index that runs down from second row to n
                        {
                            for (k = 0; k < maxOrder - 1; k++) // index to copy the elements into a sub matrix
                            {
                                if (j < y)
                                {
                                    if (k < x)
                                        mm[j][k] = a[j][k];
                                    else
                                        mm[j][k] = a[j][k + 1];
                                }
                                else
                                {
                                    if (k < x)
                                        mm[j][k] = a[j + 1][k];
                                    else
                                        mm[j][k] = a[j + 1][k + 1];
                                }
                            }
                        }
                        b[x][y] = signy * signx * calcDet(mm, maxOrder - 1) / det;
                        signy = -signy;
                    }
                    signx = -signx;
                }
            }
        }
		for(var i=0; i < maxOrder; i++)
        {
            for(var j=0; j < maxOrder; j++)
            {
              document.getElementById("A" + (i+1) + (j+1)).value = b[i][j].toFixed(3); 
            }
        }
    }

    
    function createMatrix(order, knot)
    {
		knotName = knot;
		actKnot = document.getElementById(knot);
		for (var i = 1; i <= order; i++)
		{
			var  tableRow = document.createElement("p");
			actKnot.appendChild(tableRow);
			for (var j = 1; j <= order; j++)
			{
				var field = document.createElement("input");
				field.setAttribute("id","A" + i + j);
				field.setAttribute("style","width:60px");
				tableRow.appendChild(field);
			}
		}
	}
 
 
	function selectOrder()
	{
		const input = document.getElementById('idOrder');
		maxOrder = input.value;
		a = new Array(maxOrder);
        x = new Array(maxOrder);
        y = new Array(maxOrder);
		for(var i = actKnot.childNodes.length - 1; i >= 0; i--)
		{
		   var el = actKnot.childNodes[i];
		   actKnot.removeChild(el);
		}
		createMatrix(maxOrder, knotName);
	}